package;

import flash.display.BitmapData;
import flixel.FlxG;
import flixel.FlxState;
import flixel.text.FlxTextField;
import haxe.io.Bytes;
import haxe.io.BytesData;
import openfl.Assets;
import openfl.display.Bitmap;
import openfl.display.Sprite;
import openfl.errors.Error;
import openfl.events.MouseEvent;
import openfl.net.URLRequest;
import openfl.text.TextField;
import openfl.text.TextFieldType;
import openfl.text.TextFormat;
import openfl.utils.ByteArray;
import sys.io.File;
import systools.Dialogs;

class PlayState extends FlxState
{
	private var xmlPath:TextField;
	private var outputName:TextField;
	private var xmlName:TextField;
	private var tilesetName:TextField;
	private var message:TextField;
	private var tilesetWidth:String = "";
	private var tilesetHeight:String = "";
	private var dustin:TextField;
	private var dustinOver:TextField;
	
	//Only works when compiled in Debug mode for some reason
	
	override public function create():Void
	{
		FlxG.mouse.useSystemCursor = true;
		
		var titleFormat:TextFormat = new TextFormat(null, 24);
		titleFormat.bold = true;
		titleFormat.font = "_sans";
		var title:TextField = new TextField();
		title.defaultTextFormat = titleFormat;
		title.textColor = 0xFFFFFF;
		title.width = 500;
		title.height = 30;
		title.text = "Pyxel to Tiled Conversion Tool";
		title.selectable = false;
		title.x = 320 - title.textWidth / 2;
		title.y = 4;
		FlxG.stage.addChild(title);
		
		dustin = new TextField();
		var dustinFormat:TextFormat = new TextFormat(null, 14);
		dustinFormat.font = "_sans";
		dustinFormat.bold = true;
		dustin.defaultTextFormat = dustinFormat;
		dustin.textColor = 0xCCCCCC;
		dustin.width = 130;
		dustin.height = 20;
		dustin.text = "by Dustin Auxier";
		dustin.selectable = false;
		dustin.x = 320 - dustin.textWidth / 2;
		dustin.y = 30;
		dustin.addEventListener(MouseEvent.MOUSE_OVER, dustinMouseOver);
		dustin.addEventListener(MouseEvent.CLICK, dustinClick);
		FlxG.stage.addChild(dustin);
		dustinOver = new TextField();
		var dustinFormat:TextFormat = new TextFormat(null, 14);
		dustinFormat.font = "_sans";
		dustinFormat.bold = true;
		dustinOver.defaultTextFormat = dustinFormat;
		dustinOver.textColor = 0xFFFF99;
		dustinOver.width = 130;
		dustinOver.height = 20;
		dustinOver.text = "by Dustin Auxier";
		dustinOver.selectable = false;
		dustinOver.addEventListener(MouseEvent.MOUSE_OVER, dustinMouseOver);
		dustinOver.addEventListener(MouseEvent.CLICK, dustinClick);
		dustinOver.visible = false;
		dustinOver.x = dustin.x;
		dustinOver.y = dustin.y;
		FlxG.stage.addChild(dustinOver);
		
		var details:Sprite = new Sprite();
		details.y = 45;
		FlxG.stage.addChild(details);
		
		var prompt:TextField = new TextField();
		var format:TextFormat = new TextFormat(null, 16);
		format.font = "_sans";
		prompt.defaultTextFormat = format;
		prompt.textColor = 0xCCCCCC;
		prompt.width = 500;
		prompt.height = 20;
		prompt.text = "- Export your PixelEdit tilemap as an xml file";
		prompt.selectable = false;
		prompt.x = prompt.y = 10;
		details.addChild(prompt);
		
		var prompt2:TextField = new TextField();
		prompt2.defaultTextFormat = format;
		prompt2.textColor = 0xCCCCCC;
		prompt2.width = 500;
		prompt2.height = 20;
		prompt2.text = "- Export your PixelEdit tileset with the default settings";
		prompt2.selectable = false;
		prompt2.x = 10;
		prompt2.y = 40;
		details.addChild(prompt2);
		
		//XML FILE
		var choose1:TextField = new TextField();
		choose1.defaultTextFormat = format;
		choose1.textColor = 0xCCCCCC;
		choose1.width = 500;
		choose1.height = 20;
		choose1.text = "Select your xml file:";
		choose1.selectable = false;
		choose1.x = 10;
		choose1.y = 70;
		details.addChild(choose1);
		var browseButton:Sprite = makeButton("browseButton.png","browseButtonOver.png","browseButtonDown.png",browseXMLClick);
		browseButton.x = 10;
		browseButton.y = choose1.y + 25;
		details.addChild(browseButton);
		
		var xmlLabel:TextField = new TextField();
		xmlLabel.defaultTextFormat = format;
		xmlLabel.textColor = 0xCCCCCC;
		xmlLabel.width = 500;
		xmlLabel.height = 20;
		xmlLabel.text = "XML Input:";
		xmlLabel.selectable = false;
		xmlLabel.x = browseButton.x + 80;
		xmlLabel.y = browseButton.y;
		details.addChild(xmlLabel);
		
		xmlName = new TextField();
		xmlName.defaultTextFormat = format;
		xmlName.textColor = 0xFFFFFF;
		xmlName.width = 500;
		xmlName.height = 20;
		xmlName.text = "";
		xmlName.selectable = false;
		xmlName.x = xmlLabel.x + xmlLabel.textWidth + 10;
		xmlName.y = xmlLabel.y;
		details.addChild(xmlName);
		
		//TILESET
		var choose2:TextField = new TextField();
		choose2.defaultTextFormat = format;
		choose2.textColor = 0xCCCCCC;
		choose2.width = 500;
		choose2.height = 20;
		choose2.text = "Select your tileset image:";
		choose2.selectable = false;
		choose2.x = 10;
		choose2.y = 125;
		details.addChild(choose2);
		var tilesetButton:Sprite = makeButton("browseButton.png","browseButtonOver.png","browseButtonDown.png",browseTilesetClick);
		tilesetButton.x = 10;
		tilesetButton.y = choose2.y + 25;
		details.addChild(tilesetButton);
		
		var tilesetLabel:TextField = new TextField();
		tilesetLabel.defaultTextFormat = format;
		tilesetLabel.textColor = 0xCCCCCC;
		tilesetLabel.width = 500;
		tilesetLabel.height = 20;
		tilesetLabel.text = "Tileset Input (PNG):";
		tilesetLabel.selectable = false;
		tilesetLabel.x = tilesetButton.x + 80;
		tilesetLabel.y = tilesetButton.y;
		details.addChild(tilesetLabel);
		
		tilesetName = new TextField();
		tilesetName.defaultTextFormat = format;
		tilesetName.textColor = 0xFFFFFF;
		tilesetName.width = 500;
		tilesetName.height = 20;
		tilesetName.text = "";
		tilesetName.selectable = false;
		tilesetName.x = tilesetLabel.x + tilesetLabel.textWidth + 10;
		tilesetName.y = tilesetLabel.y;
		details.addChild(tilesetName);
		
		//OUTPUT NAME
		var outputLabel:TextField = new TextField();
		outputLabel.defaultTextFormat = format;
		outputLabel.textColor = 0xCCCCCC;
		outputLabel.width = 500;
		outputLabel.height = 20;
		outputLabel.text = "TMX Output:";
		outputLabel.selectable = false;
		outputLabel.x = 10;
		outputLabel.y = 180;
		details.addChild(outputLabel);
		
		outputName = new TextField();
		outputName.type = TextFieldType.INPUT;
		outputName.defaultTextFormat = format;
		outputName.background = true;
		outputName.backgroundColor = 0x444444;
		outputName.border = true;
		outputName.borderColor = 0xFFFFFF;
		outputName.textColor = 0xFFFFFF;
		outputName.height = 24;
		outputName.width = 100;
		outputName.text = "";
		outputName.x = outputLabel.x + outputLabel.textWidth + 10;
		outputName.y = outputLabel.y;
		details.addChild(outputName);
		
		var tmx:TextField = new TextField();
		tmx.defaultTextFormat = format;
		tmx.textColor = 0xCCCCCC;
		tmx.width = 500;
		tmx.height = 20;
		tmx.text = ".tmx";
		tmx.selectable = false;
		tmx.x = outputName.x + outputName.width + 3;
		tmx.y = outputName.y;
		details.addChild(tmx);
		
		var convertButton:Sprite = makeButton("convertButton.png","convertButtonOver.png","convertButtonDown.png",convertClick);
		convertButton.x = 10;
		convertButton.y = 220;
		details.addChild(convertButton);
		
		message = new TextField();
		message.defaultTextFormat = format;
		message.textColor = 0xCCCCCC;
		message.width = 500;
		message.height = 20;
		message.text = "";
		message.selectable = false;
		message.x = 10;
		message.y = convertButton.y + 30;
		details.addChild(message);
	}
	
	private function makeButton(buttonName:String, overName:String, downName:String, clickFunc:MouseEvent -> Void):Sprite
	{
		var button = new Sprite();
		var base:Bitmap = new Bitmap(Assets.getBitmapData("assets/" + buttonName));
		button.addChild(base);
		var over = new Bitmap(Assets.getBitmapData("assets/" + overName));
		over.visible = false;
		button.addChild(over);
		var down = new Bitmap(Assets.getBitmapData("assets/" + downName));
		down.visible = false;
		button.addChild(down);
		button.addEventListener(MouseEvent.MOUSE_OVER, buttonOver);
		button.addEventListener(MouseEvent.MOUSE_DOWN, buttonDown);
		button.addEventListener(MouseEvent.CLICK, clickFunc);
		return button;
	}
	
	private function buttonOver(e:MouseEvent):Void
	{
		e.currentTarget.getChildAt(1).visible = true;
		e.currentTarget.addEventListener(MouseEvent.MOUSE_OUT, buttonOut);
	}
	private function buttonOut(e:MouseEvent):Void
	{
		e.currentTarget.getChildAt(1).visible = false;
		e.currentTarget.getChildAt(2).visible = false;
		e.currentTarget.removeEventListener(MouseEvent.MOUSE_OUT, buttonOut);
	}
	private function buttonDown(e:MouseEvent):Void
	{
		e.currentTarget.getChildAt(2).visible = true;
		e.currentTarget.addEventListener(MouseEvent.MOUSE_OUT, buttonOut);
		e.currentTarget.addEventListener(MouseEvent.MOUSE_UP, buttonUp);
	}
	private function buttonUp(e:MouseEvent):Void
	{
		e.currentTarget.getChildAt(2).visible = false;
		e.currentTarget.removeEventListener(MouseEvent.MOUSE_UP, buttonUp);
		e.currentTarget.removeEventListener(MouseEvent.MOUSE_OUT, buttonOut);
	}
	
	private function browseXMLClick(e:MouseEvent):Void
	{
		var filters: FILEFILTERS =
			{ count: 1
				, descriptions: ["XML files"]
				, extensions: ["*.xml"]	
			};
		var result:Array<String> = Dialogs.openFile("Open .xml file", "", filters);
		if (result != null)
		{
			xmlName.text = result[0];
			if (outputName.text == "")
			{
				var startIndex:Int = xmlName.text.lastIndexOf("\\") + 1;
				var tail:String = xmlName.text.substr(startIndex);
				outputName.text = tail.substring(0, tail.indexOf("."));
			}
		}
	}
	private function browseTilesetClick(e:MouseEvent):Void
	{
		var filters: FILEFILTERS =
			{ count: 1
				, descriptions: ["PNG files"]
				, extensions: ["*.png","*.gif"]	
			};
		var result:Array<String> = Dialogs.openFile("Open .png file", "", filters);
		if (result != null)
		{
			tilesetName.text = result[0];
			var data:BytesData = File.getBytes(result[0]).getData();
			tilesetWidth = Std.string(cToInt(data[16]) * (1 << 24) + cToInt(data[17]) * (1 << 16) + cToInt(data[18]) * (1 << 8) + cToInt(data[19]));
			tilesetHeight = Std.string(cToInt(data[20]) * (1 << 24) + cToInt(data[21]) * (1 << 16) + cToInt(data[22]) * (1 << 8) + cToInt(data[23]));
		}
	}
	private function cToInt(char:Unsigned_char__):Int
	{
		return Std.parseInt(Std.string(char));
	}
	
	private function convertClick(e:MouseEvent):Void
	{
		if (xmlName.text == "" || tilesetName.text == "")
		{
			message.text = "Error: Choose valid xml and png files first";
			return;
		}
		
		var pyxelXML:Xml = Xml.parse(File.getContent(xmlName.text));
		var tileMap:Xml = pyxelXML.firstElement();
		var mapWidth:String = tileMap.get("tileswide");
		var mapHeight:String = tileMap.get("tileshigh");
		var tileWidth:String = tileMap.get("tilewidth");
		var tileHeight:String = tileMap.get("tileheight");
		
		var tiledXML:Xml = Xml.parse('<?xml version="1.0" encoding="UTF-8"?><map version="1.0" orientation="orthogonal"></map>)');
		var tiledMapElement:Xml = tiledXML.firstElement();
		tiledMapElement.set("width", mapWidth);
		tiledMapElement.set("height", mapHeight);
		tiledMapElement.set("tilewidth", tileWidth);
		tiledMapElement.set("tileheight", tileHeight);
		
		var tileset:Xml = Xml.createElement("tileset");
		tileset.set("firstgid", "1");
		tileset.set("name", outputName.text + " tileset");
		tileset.set("tilewidth", tileWidth.toString());
		tileset.set("tileheight", tileHeight.toString());
		
		var image:Xml = Xml.createElement("image");
		image.set("source", tilesetName.text);
		image.set("width", tilesetWidth);
		image.set("height", tilesetHeight);
		tileset.addChild(image);
		tiledMapElement.addChild(tileset);
		
		for (layer in tileMap.elementsNamed("layer"))
		{
			var tiledLayer:Xml = Xml.createElement("layer");
			tiledLayer.set("name", layer.get("name"));
			tiledLayer.set("width", mapWidth.toString());
			tiledLayer.set("height", mapHeight.toString());
			var data:Xml = Xml.createElement("data");
			for (tile in layer.elementsNamed("tile"))
			{
				var tiledTile:Xml = Xml.createElement("tile");
				tiledTile.set("gid", Std.string((Std.parseInt(tile.get("tile")) + 1)));
				data.addChild(tiledTile);
			}
			tiledLayer.addChild(data);
			tiledMapElement.addChild(tiledLayer);
		}
		File.saveContent(outputName.text + ".tmx", tiledXML.toString());
		
		message.text = "Success! " + outputName.text + ".tmx was saved.";
	}
	
	private function dustinMouseOver(e:MouseEvent):Void
	{
		dustinOver.visible = true;
		dustinOver.addEventListener(MouseEvent.MOUSE_OUT, dustinOut);
	}
	private function dustinOut(e:MouseEvent):Void
	{
		dustinOver.visible = false;
		dustinOver.removeEventListener(MouseEvent.MOUSE_OUT, dustinOut);
	}
	private function dustinClick(e:MouseEvent):Void
	{
		flash.Lib.getURL(new URLRequest("http://dustinauxier.com"), "_blank");
	}
}